package fr.irit.diamant.ivyGUI;

import java.awt.*;
import java.awt.geom.*;
import java.awt.font.*;


import javax.swing.*;
import java.awt.event.*;

import java.io.*;
import java.util.*;

import fr.dgac.ivy.*;

public class ivyBounds extends JPanel
{	
	 static boolean enableSelect = true;	
	 BlinkTimer timer;

	// arguments : texte  crire : type police : taille police : R : G : B : alpha

	public boolean selected;
	public ivyPanel myPanel;

	private Ivy bus;
	
	final String nom;
	String content;
	int type;
	int width;
	Color color;
	float alpha;

	public ivyBounds(String name, String commande, ivyPanel p)
	{
		super();


		timer= new BlinkTimer();
		setPreferredSize(new Dimension(51,51));

		this.nom = name;
		this.content = "bla";
		this.type = Font.PLAIN;
		this.width= 10;
		this.myPanel = p;
		this.color = Color.red;
		this.alpha=0.5F;
		selected = false;

		// Traitement de la commande
	
		repaint(); 

		myPanel.add(this);
		validate();

		addMouseListener(
			new MouseAdapter() {
				public void MousePressed(MouseEvent evt)
				{
					timer.start();
				}
			}
		);
	}

  private AlphaComposite makeComposite(float alpha) {
    int type = AlphaComposite.SRC_OVER;
    return(AlphaComposite.getInstance(type, alpha));
  }

public void drawWidget(Graphics2D g2, Color color, float alpha)
{
	Font f;
	Rectangle box = new Rectangle(50,50);
   	Composite originalComposite = g2.getComposite();
	Color      oldc = g2.getColor();	

	f = new Font("SansSerif", type, width);

	// Mesure la fonte et le message
	FontRenderContext frc = g2.getFontRenderContext();
	Rectangle2D bounds = f.getStringBounds(content, frc);
	LineMetrics metrics = f.getLineMetrics(content, frc);
	float width =  (float) bounds.getWidth(); // Largeur du texte
	float lineheight = metrics.getHeight(); // Hauteur totale de la ligne
	float ascent = metrics.getAscent(); // du haut  la ligne de base
	
	// affiche un Fill Rect rouge
	g2.setComposite(makeComposite(alpha));
	g2.setColor(color);
	g2.fillRoundRect((int) box.getX(), (int) box.getY(), (int) box.getWidth(), (int) box.getHeight(), 4, 4);
	g2.setComposite(originalComposite);

	g2.setColor(oldc);     
	// Affiche le message centr dans une bote
	float x0 = (float) (box.getX() + (box.getWidth() - width)/2);
	float y0 = (float) (box.getY() + (box.getHeight() - lineheight)/2 + ascent);

	g2.setFont(f);
	g2.drawString(content,x0,y0);
	
}

public void paintComponent(Graphics g) {
    super.paintComponent(g);
    Graphics2D g2d = (Graphics2D)g;
   
      drawWidget(g2d, color, alpha);
    }

   /**
    * Allows us to turn selection on and off.
    */
   private static synchronized void enableSelect() {
      enableSelect = true;
   } // of method

   private static synchronized void disableSelect() {
      enableSelect = false;
   } // of method

/**
    * Get the color of the selected item.
    */
   public Color getSelectedColor() {
      return (color);
   } // of method

 //===========================================================================
   //===   LOOK AND FEEL METHODS   ====================================

   /**
    * Set the color 
    */
   public void setFillColor(Color newColor) {
      color = newColor;
   } // of method

   /**
    * Get the color 
    */
   public Color getFillColor() {
      return (color);
   } // of method


  //===========================================================================
   //===   BLINK TIMER AND ACTIONLISTENER INNER CLASS   ========================

   //// Blink-timer shared variables
   Color               tmpFillColor;
   Color               tmpSelectedColor;
   boolean             flagDone      = true;
   int                 count         = 0;
   BlinkActionListener blinkListener = new BlinkActionListener();

   final class BlinkTimer  extends javax.swing.Timer {

      //------------------------------------------------------------------

      public BlinkTimer() {
         super(20, null);
         addActionListener(blinkListener);
         setInitialDelay(0);
         tmpFillColor     = getFillColor();
         tmpSelectedColor = getSelectedColor();
      } // of constructor

      //------------------------------------------------------------------

      public void start() {
         flagDone = false;
         count = 0;
	disableSelect();
         super.start();
      } // of start

      //------------------------------------------------------------------

      public void stop() {
        color = tmpSelectedColor;
        ivyBounds.this.repaint();
         super.stop();
         flagDone = true;
      } // of stop

      //------------------------------------------------------------------

      public boolean isDone() {
         return (flagDone);
      } // of isDone

   } // of inner class BlinkTimer

   //===========================================================================

   final class BlinkActionListener  implements ActionListener, Serializable {

      public void actionPerformed(ActionEvent evt) {
         if (count > 2) {
            timer.stop();
            return;
         }

         if (getSelectedColor() == tmpFillColor) {
            color = tmpSelectedColor;
         }
         else {
            color = tmpFillColor;
         }
         ivyBounds.this.repaint();
         count++;
      } // of actionPerformed

      //------------------------------------------------------------------

   } // of inner class BlinkTimer

   //===   BLINK TIMER AND ACTIONLISTENER INNER CLASS   ========================
   //===========================================================================

}