package fr.irit.diamant.ivyGUI;

import java.awt.*;
import java.awt.geom.*;
import javax.swing.*;
import java.awt.event.*;

import java.util.*;

import fr.dgac.ivy.*;

public class ivyChamps extends JPanel
{		
	public boolean selected;
	public ivyPanel myPanel;

	private Ivy bus;
	private JPanel TFPanel;
	
	protected JTextField TF[];
	protected JLabel LTF[] ; // Label des zones de texte

	JButton JB;

	final String nom;
	int nb_choice;
	String content;
	String JBcontent;
		
	public ivyChamps(String name, String commande, ivyPanel p)
	{ 
		super();
		setPreferredSize(new Dimension(700,150));

		// x objets : un JLabel + un JTextField + un JButton pour tout le monde
		// arguments : 
		this.nom = name;
				
		this.myPanel = p;
		selected = false;
		this.content = "___";

		// Traitement de la commande : x arguments
		String s = commande.trim();
										
		StringTokenizer tok = new StringTokenizer(s,":");
		
		// Traitement de la variable Nombre de Radio Boutons
		String res = tok.nextToken();
		if(!res.equals("-"))
			try{
				nb_choice= Integer.parseInt(res);
			}catch(NumberFormatException nfe){System.out.println("Erreur");}
		else nb_choice=1;

		// Allocation des labels RB et JTextField
		LTF= new JLabel[nb_choice];
		TF = new JTextField[nb_choice];

		for (int i=0; i<nb_choice;i++)
		{
			// Traitement des Labels
			res = tok.nextToken();
			if(!res.equals("-")){
				LTF[i] = new JLabel(res); 
			}
			else LTF[i].setText("label "+ i);
			// Traitement des TextField
			TF[i] = new JTextField();
		}

		// Traitement de la variable JBcontent
		res = tok.nextToken();
		if(!res.equals("-"))
		{
			JBcontent=res;
		}
		else JBcontent="Valider";		


		// C'est parti !	
		TFPanel = new JPanel();
		TFPanel.setLayout(new GridLayout( nb_choice,3));

		// Affichage des Labels et TextFields
		for (int i=0; i<nb_choice;i++)
		{
			TFPanel.add(LTF[i]);
			TFPanel.add(TF[i]);
		}
	
		setVisible(true);

		setLayout(new GridLayout(1,2)); 
		
		GButton GB = new GButton();
		JB = new JButton(JBcontent);
		JB.addActionListener(GB);

		bus = new Ivy(nom,null,null);
		   
		try
		{
			bus.start("127.255.255.255:2010");

			bus.bindMsg("^ivyGUI "+nom+".getContent",new IvyMessageListener(){
				public void receive(IvyClient client, String[] args)
				{
					try{
						content = "";
						for (int i=0; i<nb_choice;i++)
						{
							content = content + "champ_" + i + "-" + TF[i].getText() + ":";
						}
						
						bus.sendMsg("ivyGUI " + nom+".content="+ivyChamps.this.content);
					}
					catch(IvyException e){
						e.printStackTrace();
					}
				}
			});

		}
		catch(IvyException ie)
		{
			ie.printStackTrace();
		}

		try{
			bus.sendMsg("ivyGUI Created=" +nom);
		}
		catch(IvyException e){
			e.printStackTrace();
		}

		this.add(TFPanel);
		this.add(JB);	
	
		myPanel.add(this);
		validate();

	}
	
	public void receive(IvyClient client, String[] args)
	{
	}		


	private class GButton implements ActionListener
	{
		public void actionPerformed(ActionEvent e)
		{
			try{
				content = "";
				for (int i=0; i<nb_choice;i++)
				{
					content = content + "champ_" + i + "-" + TF[i].getText() + ":";
				}
				bus.sendMsg("ivyGUI " +nom+".content="+ivyChamps.this.content);
			}
			catch(IvyException ie){
				ie.printStackTrace();
			}
		}
	}
}