package fr.irit.diamant.ivyGUI;

import java.awt.*;
import java.awt.geom.*;
import javax.swing.*;
import java.awt.event.*;

import java.util.*;

import fr.dgac.ivy.*;

public class ivyInput extends JPanel
{		
	public boolean selected;
	public ivyPanel myPanel;

	private Ivy bus;
	
	JLabel JL;
	JTextArea JTA;
	JButton JB;

	final String nom;
	String content;
	String JLcontent;
	int row;
	int line;
	String JBcontent;
		
	public ivyInput(String name, String commande, ivyPanel p)
	{ 
		super();
		setPreferredSize(new Dimension(700,100));

		// 3 objets : un JLabel + un JTextArea + un JButton
		// arguments : text JL + taille row+line+ texte JB
		this.nom = name;
				
		this.myPanel = p;
		selected = false;

		// Traitement de la commande : 4 arguments
		String s = commande.trim();
										
		StringTokenizer tok = new StringTokenizer(s,":");
		
		// Traitement de la variable JLcontent
		String res = tok.nextToken();
		if(!res.equals("-"))
		{
			JLcontent=res;
		}
		else JLcontent="";	
	
		// Traitement de la variable row
		res = tok.nextToken();
		if(!res.equals("-"))
		try{
			row = Integer.parseInt(res);
		}catch(NumberFormatException nfe){System.out.println("Erreur");}
		else row=3;
				
		// Traitement de la variable line
		res = tok.nextToken();
		if(!res.equals("-"))
		try{
			line = Integer.parseInt(res);
		}catch(NumberFormatException nfe){System.out.println("Erreur");}
		else line=1;

		// Traitement de la variable JBcontent
		res = tok.nextToken();
		if(!res.equals("-"))
		{
			JBcontent=res;
		}
		else JBcontent="Valider";		

		// C'est parti !	
		setLayout(new GridLayout(1,3));
		JL = new JLabel(JLcontent);
		JTA = new JTextArea(row,line);
		JTA.setEditable(true);

		GButton GB = new GButton();
		JB = new JButton(JBcontent);
		JB.addActionListener(GB);

		bus = new Ivy(nom,null,null);
		   
		try
		{
			bus.start("127.255.255.255:2010");
			
			bus.sendToSelf(true);

			bus.bindMsg("^ivyGUI "+nom+".getContent",new IvyMessageListener(){
				public void receive(IvyClient client, String[] args)
				{
					try{
						content=JTA.getText();
						bus.sendMsg("ivyGUI " +nom+".content="+ivyInput.this.content);
					}
					catch(IvyException e){
						e.printStackTrace();
					}
				}
			});
			
		}
		catch(IvyException ie)
		{
			ie.printStackTrace();
		}

		this.add(JL);
		this.add(JTA);
		this.add(JB);	
	
		myPanel.add(this);
		
		try{
			bus.sendMsg("ivyGUI Created=" +nom);
		}
		catch(IvyException e){
			e.printStackTrace();
		}
	}
	
	public void receive(IvyClient client, String[] args)
	{
	}		

	private class GButton implements ActionListener
	{
		public void actionPerformed(ActionEvent e)
		{
			try{
				content=JTA.getText();
				bus.sendMsg("ivyGUI " +nom+".content="+ivyInput.this.content);
				JTA.setText("");
			}
			catch(IvyException ie){
				ie.printStackTrace();
			}
		}
	}
}