package fr.irit.diamant.ivyGUI;


import java.awt.*;
import java.awt.geom.*;
import javax.swing.*;
import java.awt.event.*;

import edu.berkeley.guir.lib.satin.widgets.*;

import java.util.*;

import fr.dgac.ivy.*;

public class ivyPie extends JFrame
{		
	public boolean selected;
	public ivyPanel myPanel;

	private Ivy bus;

	JMenuItem item;
	PieMenu pm;

	
	final String nom;
	int nb_choice;
	String content;
	
	public ivyPie(String name, String contenu, ivyPanel p)
	{
	
		selected = false;

		// 1 objet :  Un PieMenu
		// arguments : 
		this.nom = name;
				
		this.myPanel = p;
		selected = false;
		this.content = "___";

		Container contentPane = getContentPane();


		pm = new PieMenu();
		item = new JMenuItem();


		// Traitement de la commande : x arguments
		String s = contenu.trim();
										
		StringTokenizer tok = new StringTokenizer(s,":");
		
		// Traitement de la variable Nombre d'items
		String res = tok.nextToken();
		if(!res.equals("-"))
			try{
				nb_choice= Integer.parseInt(res);
			}catch(NumberFormatException nfe){System.out.println("Erreur");}
		else nb_choice=1;

		// Allocation des Menus


		for (int i=0; i<nb_choice;i++)
		{
			// Traitement des Item
			res = tok.nextToken();
			if(!res.equals("-")){
				item = pm.add(res);
				item.addActionListener(new PieSliceListener());
			}
			else 
			{
				item = pm.add("pie"+i);
				item.addActionListener(new PieSliceListener());

			}

		}

		bus = new Ivy(nom,null,null);
		   
		try
		{
			bus.start("127.255.255.255:2010");

			
			bus.sendToSelf(true);


			bus.bindMsg("^ivyGUI "+nom+".getContent",new IvyMessageListener(){
				public void receive(IvyClient client, String[] args)
				{
					try{
						bus.sendMsg("ivyGUI " +nom+".content="+ivyPie.this.content);
					}
					catch(IvyException e){
						e.printStackTrace();
					}
				}
			});
		}
		catch(IvyException ie)
		{
			ie.printStackTrace();
		}

		try{
			bus.sendMsg("ivyGUI Created=" +nom);
		}
		catch(IvyException e){
			e.printStackTrace();
		}


		pm.addPieMenuTo(myPanel);
		contentPane.add(this);

	}


	
	public void receive(IvyClient client, String[] args)
	{
	}	



	class PieSliceListener implements ActionListener
	{

		public void actionPerformed(ActionEvent evt)
		{

				try{
					content = evt.getActionCommand();
					bus.sendMsg("ivyGUI " +nom+".content="+ivyPie.this.content);
				}
				catch(IvyException e){
					e.printStackTrace();
				}
		} // of actionPerformed
	} // of PieSliceListener	
}