package fr.irit.diamant.ivyGUI;

import java.awt.*;
import java.awt.geom.*;
import javax.swing.*;
import java.awt.event.*;

import java.util.*;

import fr.dgac.ivy.*;

public class ivyChoix extends JPanel
{		
	public boolean selected;
	public ivyPanel myPanel;

	private Ivy bus;
	private JPanel RBPanel;
	
	protected JRadioButton RB[];
	protected String RBS[] ; // contenu des RadioButton

	ButtonGroup BG;
	JButton JB;

	final String nom;
	int nb_choice;
	String content;
	String JBcontent;
		
	public ivyChoix(String name, String commande, ivyPanel p)
	{ 
		super();
		setPreferredSize(new Dimension(700,150));

		// x objets : un JRadioButton + un JButton
		// arguments : 
		this.nom = name;
				
		this.myPanel = p;
		selected = false;

		// Traitement de la commande : x arguments
		String s = commande.trim();
										
		StringTokenizer tok = new StringTokenizer(s,":");
		
		// Traitement de la variable Nombre de Radio Boutons
		String res = tok.nextToken();
		if(!res.equals("-"))
			try{
				nb_choice= Integer.parseInt(res);
			}catch(NumberFormatException nfe){System.out.println("Erreur");}
		else nb_choice=1;

		// Allocation des labels RB 
		RBS = new String[nb_choice];

		for (int i=0; i<nb_choice;i++)
		{
			// Traitement des RadioButtons
			res = tok.nextToken();
			if(!res.equals("-")){
				RBS[i] = res; 
			}
			else RBS[i] ="choix "+ i;
		}
				
		// Traitement de la variable JBcontent
		res = tok.nextToken();
		if(!res.equals("-"))
		{
			JBcontent=res;
		}
		else JBcontent="Valider";		


		// C'est parti !	
		RBPanel = new JPanel();
		RBPanel.setLayout(new GridLayout(nb_choice,1));

		RB = new JRadioButton[nb_choice];
		// Cration des RadioButton
		for (int i=0; i<nb_choice;i++)
		{
			RB[i] = new JRadioButton(RBS[i],false);
			RBPanel.add(RB[i]);
		}
		RB[0].setSelected(true);
		// GestionRB
		GestionRB gestionnaire = new GestionRB();
		for (int i=0; i<nb_choice;i++)
		{
			RB[i].addItemListener(gestionnaire);
		}

		// Creer Realtion logique entre les RB
		BG = new ButtonGroup();
		for (int i=0; i<nb_choice;i++)
		{
			BG.add(RB[i]);
		}
		setVisible(true);

		setLayout(new GridLayout(1,2)); 
		
		GButton GB = new GButton();
		JB = new JButton(JBcontent);
		JB.addActionListener(GB);

		bus = new Ivy(nom,null,null);
		   
		try
		{
			bus.start("127.255.255.255:2010");
			
			bus.sendToSelf(true);

			bus.bindMsg("^ivyGUI "+nom+".getContent",new IvyMessageListener(){
				public void receive(IvyClient client, String[] args)
				{
					try{
								bus.sendMsg("ivyGUI " + nom+".content="+ivyChoix.this.content);
					}
					catch(IvyException e){
						e.printStackTrace();
					}
				}
			});
	
		}
		catch(IvyException ie)
		{
			ie.printStackTrace();
		}

		this.add(RBPanel);
		this.add(JB);	
	
		myPanel.add(this);
		validate();
		
		try{
			bus.sendMsg("ivyGUI Created=" +nom);
		}
		catch(IvyException e){
			e.printStackTrace();
		}
	}
	
	public void receive(IvyClient client, String[] args)
	{
	}		

	private class GestionRB implements ItemListener
	{
		public void itemStateChanged(ItemEvent e)
		{
			for (int i=0;i<nb_choice;i++)
			{
				if (e.getSource() == RB[i])
					content=RBS[i];
			}
		}
	}

	private class GButton implements ActionListener
	{
		public void actionPerformed(ActionEvent e)
		{
			try{
				bus.sendMsg("ivyGUI " +nom+".content="+ivyChoix.this.content);
			}
			catch(IvyException ie){
				ie.printStackTrace();
			}
		}
	}
}