package fr.irit.diamant.ivyGUI;

import java.awt.*;
import java.awt.geom.*;
import javax.swing.*;
import java.awt.event.*;

import java.util.*;

import fr.dgac.ivy.*;

public class ivyCombo extends JPanel
{		
	public boolean selected;
	public ivyPanel myPanel;

	private Ivy bus;
	
	protected JComboBox combo;
	protected JLabel lcombo;
	protected String CS[] ; // contenu du Combo Box

	
	final String nom;
	int nb_choice;
	String content;

		
	public ivyCombo(String name, String commande, ivyPanel p)
	{ 
		super();
		setPreferredSize(new Dimension(700,150));

		// x objets : un JComboBox
		// arguments : 
		this.nom = name;
				
		this.myPanel = p;
		selected = false;

		// Traitement de la commande : x arguments
		String s = commande.trim();
										
		StringTokenizer tok = new StringTokenizer(s,":");
		
		// Traitement de la variable Nombre de composants dans le combo
		String res = tok.nextToken();
		if(!res.equals("-"))
			try{
				nb_choice= Integer.parseInt(res);
			}catch(NumberFormatException nfe){System.out.println("Erreur");}
		else nb_choice=1;

		// Allocation des labels RB 
		CS = new String[nb_choice];

		for (int i=0; i<nb_choice;i++)
		{
			// Traitement des String de la Combo
			res = tok.nextToken();
			if(!res.equals("-")){
				CS[i] = res; 
			}
			else CS[i] ="choix "+ i;
		}
				

		bus = new Ivy(nom,null,null);
		   
		try
		{
			bus.start("127.255.255.255:2010");
			
			bus.sendToSelf(true);

			bus.bindMsg("^ivyGUI "+nom+".getContent",new IvyMessageListener(){
				public void receive(IvyClient client, String[] args)
				{
					try{
								bus.sendMsg("ivyGUI " + nom+".content="+ivyCombo.this.content);
					}
					catch(IvyException e){
						e.printStackTrace();
					}
				}
			});
	
		}
		catch(IvyException ie)
		{
			ie.printStackTrace();
		}


		// C'est parti !	
		content = CS[1];
		combo = new JComboBox(CS);
		combo.setMaximumRowCount(3);


		// Listener
		combo.addItemListener( 
			new ItemListener() {
				public void itemStateChanged (ItemEvent e)
				{
					try{
						content = CS[combo.getSelectedIndex()];
						bus.sendMsg("ivyGUI " +nom+".content="+ivyCombo.this.content);
					}
					catch(IvyException ie){
						ie.printStackTrace();
					}
				}				
			}
			
		);

		this.add(combo);
	
		myPanel.add(this);
		validate();
		
		try{
			bus.sendMsg("ivyGUI Created=" +nom);
		}
		catch(IvyException e){
			e.printStackTrace();
		}
	}
	
	public void receive(IvyClient client, String[] args)
	{
	}		

}