package fr.irit.diamant.ivyGUI;

import java.awt.*;
import java.awt.geom.*;
import javax.swing.*;
import java.awt.event.*;

import java.util.*;

import fr.dgac.ivy.*;

public class ivyPanel extends JPanel implements MouseListener,MouseMotionListener
{		
	private Ivy bus;
	private Hashtable liste;
	
	int nb_click = 0;
	int x1, y1, w, h;
	
	public ivyPanel(Ivy bus_ivy)
	{
		super();
	
		bus = bus_ivy;
	
		liste = new Hashtable();
		
		try
		{
			bus.start("127.255.255.255:2010");
			bus.sendToSelf(true);

			// CREATION LABEL

			bus.bindMsg("^ivyGUI CreerLabel=(.*)",new IvyMessageListener(){
				public void receive(IvyClient client, String[] args) 
				{
					// JLabel
					new CLabel(liste,args[0],ivyPanel.this);
					validate();	
				}
			});
			
			
			// CREATION TEXTE 

			bus.bindMsg("^ivyGUI CreerTexte=(.*)",new IvyMessageListener(){
				public void receive(IvyClient client, String[] args) 
				{
					// JTextField
					new CTexte(liste,args[0],ivyPanel.this);
					validate();	
				}
			});

			// CREATION INPUT 

			bus.bindMsg("^ivyGUI CreerInput=(.*)",new IvyMessageListener(){
				public void receive(IvyClient client, String[] args) 
				{
					// Input
					new CInput(liste,args[0],ivyPanel.this);
					validate();	
				}
			});

			// CREATION OUTPUT 

			bus.bindMsg("^ivyGUI CreerOutput=(.*)",new IvyMessageListener(){
				public void receive(IvyClient client, String[] args) 
				{
					// Input
					new COutput(liste,args[0],ivyPanel.this);
					validate();	
				}
			});
			// CREATION CHOIX

			bus.bindMsg("^ivyGUI CreerChoix=(.*)",new IvyMessageListener(){
				public void receive(IvyClient client, String[] args) 
				{
					// Choix
					new CChoix(liste,args[0],ivyPanel.this);
					validate();	
				}
			});

			// CREATION BUTTON

			bus.bindMsg("^ivyGUI CreerButton=(.*)",new IvyMessageListener(){
				public void receive(IvyClient client, String[] args) 
				{
					// Button
					new CButton(liste,args[0],ivyPanel.this);
					validate();	
				}
			});

			// CREATION CHAMPS

			bus.bindMsg("^ivyGUI CreerChamps=(.*)",new IvyMessageListener(){
				public void receive(IvyClient client, String[] args) 
				{
					// Champs
					new CChamps(liste,args[0],ivyPanel.this);
					validate();	
				}
			});


			// CREATION PIE MENU

			bus.bindMsg("^ivyGUI CreerPie=(.*)",new IvyMessageListener(){
				public void receive(IvyClient client, String[] args) 
				{
					// Champs
					new CPie(liste,args[0],ivyPanel.this);
					validate();	
				}
			});

			// CREATION LIST

			bus.bindMsg("^ivyGUI CreerList=(.*)",new IvyMessageListener(){
				public void receive(IvyClient client, String[] args) 
				{
					// Input
					new CList(liste,args[0],ivyPanel.this);
					validate();	
				}
			});


			// CREATION COMBO

			bus.bindMsg("^ivyGUI CreerCombo=(.*)",new IvyMessageListener(){
				public void receive(IvyClient client, String[] args) 
				{
					// Combo
					new CCombo(liste,args[0],ivyPanel.this);
					validate();	
				}
			});


			// CREATION EXTCOMBO

			bus.bindMsg("^ivyGUI CreerExtCombo=(.*)",new IvyMessageListener(){
				public void receive(IvyClient client, String[] args) 
				{
					// Extended Combo
					new CExtCombo(liste,args[0],ivyPanel.this);
					validate();	
				}
			});


			// CREATION Bounds

			bus.bindMsg("^ivyGUI CreerBounds=(.*)",new IvyMessageListener(){
				public void receive(IvyClient client, String[] args) 
				{
					// Bounds 
					new CBounds(liste,args[0],ivyPanel.this);
					validate();	
				}
			});
			// SUPPRESSION OBJET

			bus.bindMsg("^ivyGUI Supprimer=(.*)",new IvyMessageListener(){
				public void receive(IvyClient client, String[] args) 
				{
					String s = args[0].trim();
					if(liste.containsKey(s))
					{
						liste.remove(s);
					}

					// Supprimer l'objet
					// TODO 
					//ivyPanel.this.remove(liste.get(s));
					
					validate();
					repaint();
					
				}
			});
			bus.bindMsg("^ivyGUI Supprimer$",new IvyMessageListener(){
				public void receive(IvyClient client, String[] args) 
				{
					liste.clear();
					ivyPanel.this.removeAll();
					validate();
					repaint();
					
				}
			});
		}
		catch (IvyException ie) 
		{
			ie.printStackTrace();
		}
		
		addMouseListener(this);
		addMouseMotionListener(this);

	}
	
	
	// Lorsqu'on enfonce un des boutons de la souris
	public void mousePressed(MouseEvent e)
	{
		try
		{
			bus.sendMsg("ivyGUI pressed="+e.getX()+":"+e.getY());
		}
		catch(IvyException ie)
		{
			ie.printStackTrace();
		}
	}
	
	// Lorsqu'un bouton est relach
	public void mouseReleased(MouseEvent e)
	{
		try
		{
			bus.sendMsg("ivyGUI released="+e.getX()+":"+e.getY());
		}
		catch(IvyException ie)
		{
			ie.printStackTrace();
		}
	}
	
	// Lorsqu'il y a eu un click de souris
	public void mouseClicked(MouseEvent e)
	{
	}
	
	// Lorsqu'on entre dans le composant
	public void mouseEntered(MouseEvent e)
	{
	}
	
	// Lorsqu'on sort du composent 
	public void mouseExited(MouseEvent e)
	{
	}	
		
	// Lorsqu'un bouton est enfonc et 
	// qu'on bouge la souris ensuite
	public void mouseDragged(MouseEvent e)
	{
		try
		{
			bus.sendMsg("ivyGUI dragged="+e.getX()+":"+e.getY());
		}
		catch(IvyException ie)
		{
			ie.printStackTrace();
		}
	}
	
	// Lorsqu'on bouge la souris au dessus du composant
	public void mouseMoved(MouseEvent e)
	{
	}
}