package fr.irit.diamant.ivyGUI;

import java.awt.*;
import java.awt.geom.*;
import java.awt.font.*;

import javax.swing.*;
import java.awt.event.*;

import java.util.*;

import fr.dgac.ivy.*;

public class ivyTexte extends JPanel
{		
	// arguments : texte  crire : type police : taille police

	public boolean selected;
	public ivyPanel myPanel;

	private Ivy bus;
	
	final String nom;
	String content;
	int type;
	int width;
	
	public ivyTexte(String name, String commande, ivyPanel p)
	{ 
		super();
		setPreferredSize(new Dimension(800,100));

		this.nom = name;
		this.content = "";
		this.type = Font.PLAIN;
		this.width= 10;
		this.myPanel = p;
	
		selected = false;

		// Traitement de la commande
		
		String s = commande.trim();
										
		StringTokenizer tok = new StringTokenizer(s,":");
		
		// Traitement de la variable content
		String res = tok.nextToken();
		if(!res.equals("-"))
		{
			content=res;
		}
			
		// Traitement de la variable type
		res = tok.nextToken();
		if(!res.equals("-"))
		{
			if (res.equals("ITALIC"))
				type=Font.ITALIC;
			else if (res.equals("BOLD"))
				type=Font.BOLD;
			else if (res.equals("BOLD_ITALIC"))
				type=Font.BOLD+Font.ITALIC;
		}
				
		// Traitement de la variable width
		res = tok.nextToken();
		if(!res.equals("-"))
		try{
			width = Integer.parseInt(res);
		}catch(NumberFormatException nfe){System.out.println("Erreur");}
		
		
		// C'est parti !	
		/*
		setEditable(false); // Non modifiable
		this.setText(this.content);
		this.setFont(new Font("SansSerif", type, width));
		*/
		repaint(); 

		myPanel.add(this);
		validate();

		bus = new Ivy(nom,null,null);
		   
		try
		{
			bus.start("127.255.255.255:2010");

			bus.sendToSelf(true);

			bus.bindMsg("^ivyGUI "+nom+".getContent",new IvyMessageListener(){
				public void receive(IvyClient client, String[] args)
				{
					try{
						bus.sendMsg("ivyGUI " +nom+".content="+ivyTexte.this.content);
					}
					catch(IvyException e){
						e.printStackTrace();
					}
				}
			});
		
			// FONTE
			bus.bindMsg("^ivyGUI "+nom+".setType=(.*)",new IvyMessageListener(){
				public void receive(IvyClient client, String[] args)
				{
					// TRAITEMENT BOLD, ITALIC, PLAIN, BOLD_ITALIC
					if (args[0].equals("PLAIN"))
						type=Font.PLAIN;
					else if (args[0].equals("ITALIC"))
						type=Font.ITALIC;
					else if (args[0].equals("BOLD"))
						type=Font.BOLD;
					else if (args[0].equals("BOLD_ITALIC"))
						type=Font.BOLD+Font.ITALIC;

					//setFont(new Font("SansSerif",type, width));
					repaint();
				}
			 });

			// TAILLE
			bus.bindMsg("^ivyGUI "+nom+".setWidth=(.*)",new IvyMessageListener(){
				public void receive(IvyClient client, String[] args)
				{
					try{
						width = Integer.parseInt(args[0]);
					}catch(NumberFormatException nfe){System.out.println("Erreur");}

					// setFont(new Font("Serif",type, width));
					repaint();
				}
			});

		}
		catch(IvyException ie)
		{
			ie.printStackTrace();
		}

		try{
			bus.sendMsg("ivyGUI Created=" +nom);
		}
		catch(IvyException e){
			e.printStackTrace();
		}
	}
	
	public void paintComponent(Graphics g)
	{
		Graphics2D g2 = (Graphics2D) g;
		Font f;
		Rectangle box = new Rectangle(800,100);

		
		f = new Font("SansSerif", type, width);

		super.paintComponent(g);
		// Mesure la fonte et le message
		FontRenderContext frc = g2.getFontRenderContext();
		Rectangle2D bounds = f.getStringBounds(content, frc);
		LineMetrics metrics = f.getLineMetrics(content, frc);
		float width =  (float) bounds.getWidth(); // Largeur du texte
		float lineheight = metrics.getHeight(); // Hauteur totale de la ligne
		float ascent = metrics.getAscent(); // du haut  la ligne de base
		// Affiche le message centr dans une bote
		float x0 = (float) (box.getX() + (box.getWidth() - width)/2);
		float y0 = (float) (box.getY() + (box.getHeight() - lineheight)/2 + ascent);
		g2.setFont(f);
		g2.drawString(content,x0,y0);
	}

	public void receive(IvyClient client, String[] args)
	{
	}		
}